VERSION 5.00
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "MSCOMM32.OCX"
Begin VB.Form OScope 
   Caption         =   "OScope"
   ClientHeight    =   5415
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   9420
   LinkTopic       =   "Form1"
   ScaleHeight     =   361
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   628
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox OScreen 
      BackColor       =   &H00000000&
      ForeColor       =   &H0000FF00&
      Height          =   4455
      Left            =   120
      ScaleHeight     =   293
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   613
      TabIndex        =   0
      Top             =   120
      Width           =   9255
   End
   Begin MSCommLib.MSComm MSComm1 
      Left            =   8760
      Top             =   4800
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
      CommPort        =   4
      DTREnable       =   -1  'True
      Handshaking     =   2
      InBufferSize    =   4096
      NullDiscard     =   -1  'True
      BaudRate        =   19200
   End
End
Attribute VB_Name = "OScope"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Declare Sub Sleep Lib "kernel32" (ByVal tm As Long)
Dim Grid As Boolean  ' grid on/off
Dim xpos As Integer  ' current x
Dim xmax As Integer  ' max x
Dim ymax As Integer  ' max y
Dim xlast As Integer ' laxt x/y
Dim ylast As Integer
Dim sstring As String ' input string

Private Sub Form_GotFocus()  ' force focus for keyboard cmds
OScreen.SetFocus
End Sub

Private Sub Form_Load()   ' Initial setup
Grid = True
MSComm1.RThreshold = 256
CommStart
End Sub


Private Sub Form_Resize()   ' fill window with scope image
OScreen.Top = 0
OScreen.Left = 0
OScreen.Width = OScope.ScaleWidth
OScreen.Height = OScope.ScaleHeight
xmax = OScreen.ScaleWidth
ymax = OScreen.ScaleHeight
OClear   ' clear screen so we don't have wierd results
End Sub

Private Sub Form_Unload(Cancel As Integer)  ' Done
CommStop
End
End Sub



Private Sub MSComm1_OnComm()
evnt = MSComm1.CommEvent
' If we get a framing error at the start the control sometimes
' refuses to work :-(
If evnt > 1000 Then   ' some sort of error!
  MSComm1.PortOpen = False
  DoEvents
  Sleep (1000)
  DoEvents
  MSComm1.PortOpen = True
End If
If evnt = comEvReceive Then  ' got characters
  Dim n As Integer
  Dim v As String
  Dim nm As String
  sstring = sstring & MSComm1.Input   ' add to any left over from last time
  ' Sync up with whole number (4 digits + CR)
  Do While Mid(sstring, 5, 1) <> Chr(13)
    sstring = Mid(sstring, 2)
  Loop
  ' Pick out numbers
  Do While Len(sstring) >= 5
    n = Val("&H" & Mid(sstring, 1, 4))
    ' n between 0 and 1023
    Dim y As Single
    Dim volt As Single
    Dim yint As Integer
    y = ymax
    y = y * n / 1024
    If xpos Mod 64 = 0 Then
      volt = (n / 1024#) * 5
      OScope.Caption = "Last = " & Str(volt) & "V"
    End If
    yint = ymax - Int(y)
    If xlast <> -1 Then OScreen.Line (xlast, ylast)-(xpos, yint)
    xlast = xpos
    ylast = yint
    DoEvents   ' be sure to redraw
    xpos = xpos + 1
    If xpos > xmax Then
      OClear
    End If
    sstring = Mid(sstring, 6)  ' remove this number
  Loop
End If

End Sub


' Show commands
Private Sub OScreen_Click()
Commands.Show vbModal
End Sub

' Handle keyboard commands
Private Sub OScreen_KeyPress(KeyAscii As Integer)
If (KeyAscii = Asc("S") Or KeyAscii = Asc("s")) And MSComm1.PortOpen Then
  CommStop
End If
If (KeyAscii = Asc("R") Or KeyAscii = Asc("r")) And Not MSComm1.PortOpen Then
  CommStart
End If
If (KeyAscii = Asc("C") Or KeyAscii = Asc("c")) Then
  Clipboard.Clear
  CopyEntirePicture OScreen
End If
If (KeyAscii = Asc("G") Or KeyAscii = Asc("g")) Then
  Grid = Not Grid
  If Grid Then DoGrid
End If
If (KeyAscii = Asc("K") Or KeyAscii = Asc("k")) Then
  Dialog.Show vbModal
End If
End Sub

' Clear screen and reset parameters
Private Sub OClear()
OScreen.Cls
If Grid Then DoGrid
xpos = 0
xlast = -1
ylast = -1
End Sub

' draw grid
Private Sub DoGrid()
Dim x As Integer
Dim y As Integer
Dim oldcolor
oldcolor = OScreen.ForeColor
OScreen.ForeColor = &H808080
For x = 0 To xmax Step xmax / 10
 OScreen.Line (x, 0)-(x, ymax)
Next
For y = 0 To ymax Step ymax / 10
 OScreen.Line (0, y)-(xmax, y)
Next
OScreen.ForeColor = oldcolor
End Sub

' Shutdown com port
Public Sub CommStop()
If MSComm1.PortOpen = True Then
  MSComm1.PortOpen = False
End If
End Sub

' Start com port
Public Sub CommStart()
Form_Resize
On Error Resume Next
MSComm1.PortOpen = True
If Err.Number <> 0 Then
  MsgBox "Can't open Com Port"
End If
End Sub

' Do a command from external source
Public Sub cmd(s As String)
OScreen_KeyPress Asc(s)
End Sub
